Ruby - Bug #15267

File.basename + File.extname does not restore the original name
10/29/2018 06:25 AM - nobu (Nobuyoshi Nakada)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: Backport: 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5:
UNKNOWN

Description
Related to #15224, | found the case File.basename(name, '.*')+File.extname(name) == File.basename(name) is not true.

name = 'file.'

File.basename (name, '.*') #=> "name"
File.extname (name) #=> ""

Both do not contain the last dot.

basename(1) seems to result in the base name with the dot, when stripping a wildcard suffix.

$ basename name. '.*'
name.

Related issues:
Related to Ruby - Bug #15244: Method #extname return empty string if filename... Closed

Associated revisions

Revision e169ad93f44e1944ecf7bb65133fd34e8b868ea8 - 10/17/2019 09:51 AM - nobu (Nobuyoshi Nakada)

Fixed File.exthame at a name ending with a dot

File.extname now returns a dot string at a name ending with a dot.
[Bug #15267]

Revision e169ad93f44e1944ecf7bb65133fd34e8b868ea8 - 10/17/2019 09:51 AM - nobu (Nobuyoshi Nakada)
Fixed File.exthame at a name ending with a dot

File.extname now returns a dot string at a name ending with a dot.
[Bug #15267]

Revision e169ad93 - 10/17/2019 09:51 AM - nobu (Nobuyoshi Nakada)
Fixed File.exthame at a name ending with a dot

File.extname now returns a dot string at a name ending with a dot.
[Bug #15267]

Revision 4f13927f1fe06a5fe23e25448d9adc80031e0bad - 10/17/2019 10:43 AM - nobu (Nobuyoshi Nakada)
[DOC] no change on Windows [Bug #15267] [ci skip]

Revision 4f13927f1fe06a5fe23e25448d9adc80031e0bad - 10/17/2019 10:43 AM - nobu (Nobuyoshi Nakada)
[DOC] no change on Windows [Bug #15267] [ci skip]

Revision 4f13927f - 10/17/2019 10:43 AM - nobu (Nobuyoshi Nakada)
[DOC] no change on Windows [Bug #15267] [ci skip]

Revision 61aff0cd189e67fa6f2565639ad0128fa33b88fc - 12/21/2019 05:42 PM - U.Nakamura

Should return "." for File.extname("file.") also on Windows

But not changes another cases, such as "file.rb."
https://bugs.ruby-lang.org/issues/15224

[Bug #15267]
Revision 61aff0cd189e67fa6f2565639ad0128fa33b88fc - 12/21/2019 05:42 PM - U.Nakamura
Should return "." for File.extname("file.") also on Windows

But not changes another cases, such as "file.rb."
[Bug #15267]

Revision 61aff0cd - 12/21/2019 05:42 PM - U.Nakamura
Should return "." for File.extname("file.") also on Windows

But not changes another cases, such as "file.rb."
[Bug #15267]

Revision 1bf8d5e9797f6304b2e27cb7f42d467184de0ff4 - 12/22/2019 03:16 PM - znz (Kazuhiro NISHIYAMA)
Changed behavior on windows platforms too [ci skip]

at 61aff0cd189e67fa6f2565639ad0128fa33b88fc [Bug #15267]

Revision 1bf8d5e9797f6304b2e27cb7f42d467184de0ff4 - 12/22/2019 03:16 PM - znz (Kazuhiro NISHIYAMA)
Changed behavior on windows platforms too [ci skip]

at 61aff0cd189e67fa6f2565639ad0128fa33b88fc [Bug #15267]

Revision 1bf8d5e9 - 12/22/2019 03:16 PM - znz (Kazuhiro NISHIYAMA)

Changed behavior on windows platforms too [ci skip]

at 61aff0cd189e67fa6f2565639ad0128fa33b88fc [Bug #15267]

History

#1 - 08/13/2019 11:16 PM - jeremyevans0 (Jeremy Evans)
- Related to Bug #15244: Method #extname return empty string if filename is dot ('.') added

#2 - 08/13/2019 11:49 PM - jeremyevans0 (Jeremy Evans)
- File file-basename-trailing-dot-15267.patch added

Attached is a patch that fixes this issue. With the patch:

name = 'file.'

File.basename (name, '.*')

# => "file."
File.extname (name)
4 => nm

#3 - 10/17/2019 05:14 AM - naruse (Yui NARUSE)

basename(1) seems to result in the base name with the dot, when stripping a wildcard suffix.

basename(1) doesn't handle wildcard.
https://pubs.opengroup.org/onlinepubs/9699919799/utilities/basename.html

#4 - 10/17/2019 05:41 AM - akr (Akira Tanaka)
I think we should change File.extname instead of File.basename, as:

File.basename ("name.", ".*") #=> "name"
File.extname ("name.") #=> "."

We can explain File.extname as:
File.extname(x) returns what File.basename(x, ".*") removes.

#5 - 10/17/2019 06:05 AM - nobu (Nobuyoshi Nakada)
https://github.com/ruby/ruby/pull/2565
https://pubs.opengroup.org/onlinepubs/9699919799/utilities/basename.html
https://github.com/ruby/ruby/pull/2565

#6 - 10/17/2019 09:52 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed

Applied in changeset gitle169ad93f44e1944ecf7bb65133fd34e8b868ea8.

Fixed File.extname at a name ending with a dot

File.extname now returns a dot string at a name ending with a dot.
[Bug #15267]

Files
file-basename-trailing-dot-15267.patch 1.96 KB 08/13/2019 jeremyevans0 (Jeremy Evans)
